      subroutine qqMATRIX(p,matrixsq)

c  2-3 squared matrix elements for u u -> u u g
c  sumed over spin and colors and averaged over initial spin ,color
c  final state identical factor considered      

      implicit none
      double precision p(0:3,5)
      double complex f1(6), f2(6), f3(6), f4(6), f5(6), i1(6), i2(6)
      double complex color(4, 0:6), coloraux(4, 0:6), vertex(3), vertex1
      double precision plus, minus, N
      double precision gdot, t13, t24, t14, t23
      double precision matrixsq(2), averagefactor(2)
      integer i,j,ii,jj,nh1,nh2,nh3,nh4,nh5,ckey(3)
      parameter (plus=1.d0)
      parameter (minus=-1.d0) 
      parameter (N=3.d0)
      external gdot
      include "calc.h"


      matrixsq(1)=0.d0
      matrixsq(2)=0.d0
      averagefactor(1)=1.d0/4.d0/9.d0
      averagefactor(2)=1.d0/8.d0/9.d0
      ckey=0
      do i=1, 3
      if((gs2(i).ne.0.d0).or.(go2(i).ne.0.d0)) then
      ckey(i)=1
      endif
      enddo


c helicity amplitudes calculation ! crossing here
      do nh1=-1, 1,2
      do nh2=-1, 1,2
      do nh3=-1, 1,2
      do nh4=-1, 1,2
      do nh5=-1, 1,2

      if(((ckey(1).ne.0).and.((nh1+nh2+nh3+nh4).eq.-4))
     -   .or.((ckey(3).ne.0).and.((nh1+nh2+nh3+nh4).eq.4))
     -   .or.((ckey(2).ne.0).and.((abs(nh1+nh2)+abs(nh3+nh4)).eq.0))) then

      do i=1, 4
      do j=0, 6
      color(i, j)=(0.d0, 0.d0)
      enddo
      enddo

      call ixxxxx(p(0, 1), 0.d0, nh1, 1, f1)
      call ixxxxx(p(0, 2), 0.d0, nh2, 1, f2)
      call oxxxxx(p(0, 3), 0.d0, nh3, 1, f3)
      call oxxxxx(p(0, 4), 0.d0, nh4, 1, f4)
      call vxxxxx(p(0, 5), 0.d0, nh5, 1, f5)
      t13=-2.d0*gdot(p(0, 1), p(0, 3))
      t14=-2.d0*gdot(p(0, 1), p(0, 4))
      t23=-2.d0*gdot(p(0, 2), p(0, 3))
      t24=-2.d0*gdot(p(0, 2), p(0, 4))

c QCD t-channel

      call fvixxx(f1, f5, i1)
      call ci4xxx(i1, f2, f3, f4, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t24
      vertex(2)=vertex(2)/2.d0
      
      do j=1, 3
      color(1, 1+2*(j-1))=color(1, 1+2*(j-1))+plus*vertex(j) 
      color(1, 2+2*(j-1))=color(1, 2+2*(j-1))-plus*vertex(j)/2.d0/N
      color(3, 2+2*(j-1))=color(3, 2+2*(j-1))+plus*vertex(j)/2.d0
      enddo
      color(1, 0)=color(1, 0)-plus*vertex1/2.d0/N
      color(3, 0)=color(3, 0)+plus*vertex1/2.d0

      call fvoxxx(f3, f5, i1)
      call ci4xxx(f1, f2, i1, f4, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t24
      vertex(2)=vertex(2)/2.d0
      
      do j=1, 3
      color(1, 1+2*(j-1))=color(1, 1+2*(j-1))+plus*vertex(j) 
      color(1, 2+2*(j-1))=color(1, 2+2*(j-1))-plus*vertex(j)/2.d0/N 
      color(4, 2+2*(j-1))=color(4, 2+2*(j-1))+plus*vertex(j)/2.d0
      enddo
      color(1, 0)=color(1, 0)-plus*vertex1/2.d0/N 
      color(4, 0)=color(4, 0)+plus*vertex1/2.d0

      call fvixxx(f2, f5, i1)
      call ci4xxx(f1, i1, f3, f4, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t13
      vertex(2)=vertex(2)/2.d0
      
      do j=1, 3
      color(2, 1+2*(j-1))=color(2, 1+2*(j-1))+plus*vertex(j) 
      color(2, 2+2*(j-1))=color(2, 2+2*(j-1))-plus*vertex(j)/2.d0/N 
      color(4, 2+2*(j-1))=color(4, 2+2*(j-1))+plus*vertex(j)/2.d0 
      enddo
      color(2, 0)=color(2, 0)-plus*vertex1/2.d0/N 
      color(4, 0)=color(4, 0)+plus*vertex1/2.d0 

      call fvoxxx(f4, f5, i1)
      call ci4xxx(f1, f2, f3, i1, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t13
      vertex(2)=vertex(2)/2.d0
      
      do j=1, 3
      color(2, 1+2*(j-1))=color(2, 1+2*(j-1))+plus*vertex(j) 
      color(2, 2+2*(j-1))=color(2, 2+2*(j-1))-plus*vertex(j)/2.d0/N 
      color(3, 2+2*(j-1))=color(3, 2+2*(j-1))+plus*vertex(j)/2.d0 
      enddo
      color(2, 0)=color(2, 0)-plus*vertex1/2.d0/N 
      color(3, 0)=color(3, 0)+plus*vertex1/2.d0 

      call jioxxx(f1, f3, i1)
      call ggoxxx(f5, i1, i2)
      call iovxxx(f2, f4, i2, vertex1)

      color(3, 0)=color(3, 0)+plus*vertex1/2.d0 
      color(4, 0)=color(4, 0)-plus*vertex1/2.d0 

ccccccc

      do i=1, 4
      do j=0, 6
      coloraux(i, j)=color(i, j)
      enddo
      enddo


c QCD u-channel

      call fvixxx(f1, f5, i1)
      call ci4xxx(i1, f2, f4, f3, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t23
      vertex(2)=vertex(2)/2.d0
      
      do j=1, 3
      color(3, 1+2*(j-1))=color(3, 1+2*(j-1))+minus*vertex(j) 
      color(3, 2+2*(j-1))=color(3, 2+2*(j-1))-minus*vertex(j)/2.d0/N
      color(1, 2+2*(j-1))=color(1, 2+2*(j-1))+minus*vertex(j)/2.d0
      enddo
      color(3, 0)=color(3, 0)-minus*vertex1/2.d0/N
      color(1, 0)=color(1, 0)+minus*vertex1/2.d0

      call fvoxxx(f4, f5, i1)
      call ci4xxx(f1, f2, i1, f3, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t23
      vertex(2)=vertex(2)/2.d0
      
      do j=1, 3
      color(3, 1+2*(j-1))=color(3, 1+2*(j-1))+minus*vertex(j) 
      color(3, 2+2*(j-1))=color(3, 2+2*(j-1))-minus*vertex(j)/2.d0/N
      color(2, 2+2*(j-1))=color(2, 2+2*(j-1))+minus*vertex(j)/2.d0
      enddo
      color(3, 0)=color(3, 0)-minus*vertex1/2.d0/N 
      color(2, 0)=color(2, 0)+minus*vertex1/2.d0

      call fvixxx(f2, f5, i1)
      call ci4xxx(f1, i1, f4, f3, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t14
      vertex(2)=vertex(2)/2.d0
      
      do j=1, 3
      color(4, 1+2*(j-1))=color(4, 1+2*(j-1))+minus*vertex(j) 
      color(4, 2+2*(j-1))=color(4, 2+2*(j-1))-minus*vertex(j)/2.d0/N
      color(2, 2+2*(j-1))=color(2, 2+2*(j-1))+minus*vertex(j)/2.d0
      enddo
      color(4, 0)=color(4, 0)-minus*vertex1/2.d0/N 
      color(2, 0)=color(2, 0)+minus*vertex1/2.d0 

      call fvoxxx(f3, f5, i1)
      call ci4xxx(f1, f2, f4, i1, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t14
      vertex(2)=vertex(2)/2.d0
      
      do j=1, 3
      color(4, 1+2*(j-1))=color(4, 1+2*(j-1))+minus*vertex(j) 
      color(4, 2+2*(j-1))=color(4, 2+2*(j-1))-minus*vertex(j)/2.d0/N
      color(1, 2+2*(j-1))=color(1, 2+2*(j-1))+minus*vertex(j)/2.d0
      enddo
      color(4, 0)=color(4, 0)-minus*vertex1/2.d0/N 
      color(1, 0)=color(1, 0)+minus*vertex1/2.d0 

      call jioxxx(f1, f4, i1)
      call ggoxxx(f5, i1, i2)
      call iovxxx(f2, f3, i2, vertex1)

      color(1, 0)=color(1, 0)+minus*vertex1/2.d0 
      color(2, 0)=color(2, 0)-minus*vertex1/2.d0 

cccc
      do i=1, 4
      do j=0, 6
      do ii=1, 4
      do jj=0, 6
      if(zeronot1(j ,jj).ne.0) then 
      matrixsq(1)=matrixsq(1)+colreal(i,ii)*coupl(j, jj)*
     -        dble(coloraux(i, j)*conjg(coloraux(ii, jj)))
      matrixsq(2)=matrixsq(2)+colreal(i,ii)*coupl(j, jj)*
     -        dble(color(i, j)*conjg(color(ii, jj)))
      endif
      enddo
      enddo
      enddo
      enddo

      endif

      enddo
      enddo
      enddo
      enddo
      enddo
c end of helicity calculations

      matrixsq(1)=4.d0*pi*alfas*averagefactor(1)*matrixsq(1)
      matrixsq(2)=4.d0*pi*alfas*averagefactor(2)*matrixsq(2)

      end subroutine
